pcl::FeatureFromLabels< PointInT, PointLT, PointOutT > Class Template Reference

`#include <pcl/features/feature.h>`

Inheritance diagram for pcl::FeatureFromLabels< PointInT, PointLT, PointOutT >:

## Public Types

using | Ptr = shared_ptr< FeatureFromLabels< PointInT, PointLT, PointOutT > >
using | ConstPtr = shared_ptr< const FeatureFromLabels< PointInT, PointLT, PointOutT > >
Public Types inherited from pcl::Feature< PointInT, PointOutT >
using | BaseClass = PCLBase< PointInT >
using | Ptr = shared_ptr< Feature< PointInT, PointOutT > >
using | ConstPtr = shared_ptr< const Feature< PointInT, PointOutT > >
using | KdTree = pcl::search::Search< PointInT >
using | KdTreePtr = typename KdTree::Ptr
using | PointCloudIn = pcl::PointCloud< PointInT >
using | PointCloudInPtr = typename PointCloudIn::Ptr
using | PointCloudInConstPtr = typename PointCloudIn::ConstPtr
using | PointCloudOut = pcl::PointCloud< PointOutT >
using | SearchMethod = std::function< int(std::size_t, double, std::vector< int > &, std::vector< float > &)>
using | SearchMethodSurface = std::function< int(const PointCloudIn &cloud, std::size_t index, double, std::vector< int > &, std::vector< float > &)>
Public Types inherited from pcl::PCLBase< PointInT >
using | PointCloud = pcl::PointCloud< PointInT >
using | PointCloudPtr = typename PointCloud::Ptr
using | PointCloudConstPtr = typename PointCloud::ConstPtr
using | PointIndicesPtr = PointIndices::Ptr
using | PointIndicesConstPtr = PointIndices::ConstPtr

## Public Member Functions

| FeatureFromLabels ()
| Empty constructor. More...
virtual | ~FeatureFromLabels ()
| Empty destructor. More...
void | setInputLabels (const PointCloudLConstPtr &labels)
| Provide a pointer to the input dataset that contains the point labels of the XYZ dataset. More...
PointCloudLConstPtr | getInputLabels () const
| Get a pointer to the labels of the input XYZ point cloud dataset. More...
Public Member Functions inherited from pcl::Feature< PointInT, PointOutT >
| Feature ()
| Empty constructor. More...
virtual | ~Feature ()
| Empty destructor. More...
void | setSearchSurface (const PointCloudInConstPtr &cloud)
| Provide a pointer to a dataset to add additional information to estimate the features for every point in the input dataset. More...
PointCloudInConstPtr | getSearchSurface () const
| Get a pointer to the surface point cloud dataset. More...
void | setSearchMethod (const KdTreePtr &tree)
| Provide a pointer to the search object. More...
KdTreePtr | getSearchMethod () const
| Get a pointer to the search method used. More...
double | getSearchParameter () const
| Get the internal search parameter. More...
void | setKSearch (int k)
| Set the number of k nearest neighbors to use for the feature estimation. More...
int | getKSearch () const
| get the number of k nearest neighbors used for the feature estimation. More...
void | setRadiusSearch (double radius)
| Set the sphere radius that is to be used for determining the nearest neighbors used for the feature estimation. More...
double | getRadiusSearch () const
| Get the sphere radius used for determining the neighbors. More...
void | compute (PointCloudOut &output)
| Base method for feature estimation for all points given in <setInputCloud (), setIndices ()> using the surface in setSearchSurface () and the spatial locator in setSearchMethod () More...
Public Member Functions inherited from pcl::PCLBase< PointInT >
| PCLBase ()
| Empty constructor. More...
| PCLBase (const PCLBase &base)
| Copy constructor. More...
virtual | ~PCLBase ()
| Destructor. More...
virtual void | setInputCloud (const PointCloudConstPtr &cloud)
| Provide a pointer to the input dataset. More...
const PointCloudConstPtr | getInputCloud () const
| Get a pointer to the input point cloud dataset. More...
virtual void | setIndices (const IndicesPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const IndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (const PointIndicesConstPtr &indices)
| Provide a pointer to the vector of indices that represents the input data. More...
virtual void | setIndices (std::size_t row_start, std::size_t col_start, std::size_t nb_rows, std::size_t nb_cols)
| Set the indices for the points laying within an interest region of the point cloud. More...
const IndicesPtr | getIndices ()
| Get a pointer to the vector of indices used. More...
const IndicesConstPtr | getIndices () const
| Get a pointer to the vector of indices used. More...
const PointInT & | operator[] (std::size_t pos) const
| Override PointCloud operator[] to shorten code. More...

## Protected Member Functions

virtual bool | initCompute ()
| This method should get called before starting the actual computation. More...
Protected Member Functions inherited from pcl::Feature< PointInT, PointOutT >
const std::string & | getClassName () const
| Get a string representation of the name of this class. More...
virtual bool | deinitCompute ()
| This method should get called after ending the actual computation. More...
int | searchForNeighbors (std::size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
int | searchForNeighbors (const PointCloudIn &cloud, std::size_t index, double parameter, std::vector< int > &indices, std::vector< float > &distances) const
| Search for k-nearest neighbors using the spatial locator from setSearchmethod, and the given surface from setSearchSurface. More...
Protected Member Functions inherited from pcl::PCLBase< PointInT >
bool | initCompute ()
| This method should get called before starting the actual computation. More...
bool | deinitCompute ()
| This method should get called after finishing the actual computation. More...

## Protected Attributes

PointCloudLConstPtr | labels_
| A pointer to the input dataset that contains the point labels of the XYZ dataset. More...
Protected Attributes inherited from pcl::Feature< PointInT, PointOutT >
std::string | feature_name_
| The feature name. More...
SearchMethodSurface | search_method_surface_
| The search method template for points. More...
PointCloudInConstPtr | surface_
| An input point cloud describing the surface that is to be used for nearest neighbors estimation. More...
KdTreePtr | tree_
| A pointer to the spatial search object. More...
double | search_parameter_
| The actual search parameter (from either search_radius_ or k_). More...
double | search_radius_
| The nearest neighbors search radius for each point. More...
int | k_
| The number of K nearest neighbors to use for each point. More...
bool | fake_surface_
| If no surface is given, we use the input PointCloud as the surface. More...
Protected Attributes inherited from pcl::PCLBase< PointInT >
PointCloudConstPtr | input_
| The input point cloud dataset. More...
IndicesPtr | indices_
| A pointer to the vector of point indices to use. More...
bool | use_indices_
| Set to true if point indices are used. More...
bool | fake_indices_
| If no set of indices are given, we construct a set of fake indices that mimic the input PointCloud. More...

## Detailed Description

### template<typename PointInT, typename PointLT, typename PointOutT>
class pcl::FeatureFromLabels< PointInT, PointLT, PointOutT >

Definition at line 368 of file feature.h.

## Member Typedef Documentation

## ConstPtr

template<typename PointInT , typename PointLT , typename PointOutT >

using pcl::FeatureFromLabels< PointInT, PointLT, PointOutT >::ConstPtr = shared_ptr< const FeatureFromLabels<PointInT, PointLT, PointOutT> >

Definition at line 382 of file feature.h.

## Ptr

template<typename PointInT , typename PointLT , typename PointOutT >

using pcl::FeatureFromLabels< PointInT, PointLT, PointOutT >::Ptr = shared_ptr< FeatureFromLabels<PointInT, PointLT, PointOutT> >

Definition at line 381 of file feature.h.

## Constructor & Destructor Documentation

## FeatureFromLabels()

template<typename PointInT , typename PointLT , typename PointOutT >

pcl::FeatureFromLabels< PointInT, PointLT, PointOutT >::FeatureFromLabels | ( |  | ) |

inline

Empty constructor.

Definition at line 391 of file feature.h.

References pcl::Feature< PointInT, PointOutT >::k_.

## ~FeatureFromLabels()

template<typename PointInT , typename PointLT , typename PointOutT >

virtual pcl::FeatureFromLabels< PointInT, PointLT, PointOutT >::~FeatureFromLabels | ( |  | ) |

inline virtual

Empty destructor.

Definition at line 397 of file feature.h.

## Member Function Documentation

## getInputLabels()

template<typename PointInT , typename PointLT , typename PointOutT >

PointCloudLConstPtr pcl::FeatureFromLabels< PointInT, PointLT, PointOutT >::getInputLabels | ( |  | ) | const

inline

Get a pointer to the labels of the input XYZ point cloud dataset.

Definition at line 413 of file feature.h.

References pcl::FeatureFromLabels< PointInT, PointLT, PointOutT >::labels_.

## initCompute()

template<typename PointInT , typename PointLT , typename PointOutT >

bool pcl::FeatureFromLabels< PointInT, PointLT, PointOutT >::initCompute | ( |  | ) |

protected virtual

This method should get called before starting the actual computation.

Reimplemented from pcl::Feature< PointInT, PointOutT >.

Definition at line 265 of file feature.hpp.

## setInputLabels()

template<typename PointInT , typename PointLT , typename PointOutT >

void pcl::FeatureFromLabels< PointInT, PointLT, PointOutT >::setInputLabels | ( | const PointCloudLConstPtr & | labels | ) |

inline

Provide a pointer to the input dataset that contains the point labels of the XYZ dataset.

In case of search surface is set to be different from the input cloud, labels should correspond to the search surface, not the input cloud!

Parameters

  [in] | labels | the const boost shared pointer to a PointCloud of labels.

Definition at line 406 of file feature.h.

References pcl::FeatureFromLabels< PointInT, PointLT, PointOutT >::labels_.

## Member Data Documentation

## labels_

template<typename PointInT , typename PointLT , typename PointOutT >

PointCloudLConstPtr pcl::FeatureFromLabels< PointInT, PointLT, PointOutT >::labels_

protected

A pointer to the input dataset that contains the point labels of the XYZ dataset.

Definition at line 422 of file feature.h.

Referenced by pcl::FeatureFromLabels< PointInT, PointLT, PointOutT >::getInputLabels(), and pcl::FeatureFromLabels< PointInT, PointLT, PointOutT >::setInputLabels().

The documentation for this class was generated from the following files:

- pcl/features/feature.h
- pcl/features/impl/feature.hpp